程序员最近都爱上了这个网站  程序员们快来瞅瞅吧!  it98k网:it98k.com

本站消息

站长简介/公众号

  出租广告位,需要合作请联系站长


+关注
已关注

分类  

暂无分类

标签  

暂无标签

日期归档  

暂无数据

Java异常机制

发布于2021-03-10 18:43     阅读(1429)     评论(0)     点赞(27)     收藏(5)


Java异常机制

异常

异常是程序中的一些错误。但并不是所有的错误都是异常,并且错误有时候是可以避免的。

异常的分类:

  • 检查性异常:最具代表的检查性异常是用户错误或问题引起的异常,这是程序员无法预见的。例如要打开一个不存在文件时,一个异常就发生了,这些异常在编译时不能被简单地忽略。
  • 运行时异常: 运行时异常是可能被程序员避免的异常。与检查性异常相反,运行时异常可以在编译时被忽略。
  • 错误(Error): 错误不是异常,而是脱离程序员控制的问题。错误在代码中通常被忽略。例如,当栈溢出时,一个错误就发生了,在编译时同样检查不到。

示例:

package com.wmwx.exception;

public class Demo01 {
    public static void main(String[] args) {
        new Demo01().a();           //抛出异常:StackOverflowError
        System.out.println(11/0);   //抛出异常:ArithmeticException
        System.out.println()        //抛出异常:Error
    }

    public void a(){
        b();
    }

    public void b(){
        a();
    }
}

异常体系结构

Java把异常当做对象来处理,并定义了一个基类java.lang.Throwable作为所有异常的超类。这些异常分为两大类,即异常(Exception)和错误(Error)。其中,Exception类有两个主要的子类,即 IOException 类和 RuntimeException 类。

Error

Error类对象由虚拟机生成并抛出,大多数错误与代码编写者所执行的操作无关。

常见的错误如Java虚拟机运行错误(VirtualMachineError),当JVM不再有继续执行操作所需的内存资源时,将出现OutOfMemoryError。这些异常发生时,Java虚拟机一般会选择将线程中止。

还有发生在虚拟机试图执行应用时的错误,如类定义错误(NoClassDefFoundError)、链接错误(LinkageError)等,这些错误是不可查的。因为它们在应用程序的控制和处理程序能力之外,而且绝大多数是程序运行时不允许出现的状况。

Exception

在Exception类的分支中有一个重要的子类 RuntimeException(运行时异常),其中包含以下异常:

  • ArrayIndexOutOfBoundsException(数组下标越界)

  • NullPointerException(空指针异常)

  • ArithmeticException(算术异常)

  • MissingResourceException(丢失资源)

  • ClassNotFoundException(找不到类)

这些异常是不检查异常,程序中可以选择捕获处理,也可以不处理。这些异常一般是由程序逻辑错误引起的,程序应该从逻辑角度尽可能避免这类异常的发生。

Error和Exception的区别:

  • Error 通常是灾难性的致命的错误,是程序无法控制和处理的,当出现这些异常时,Java虚拟机(JVM)一般会选择终止线程
  • Exception 通常情况下是可以被程序处理的,并且在程序中应该尽可能的去处理这些异常。

捕获异常

使用 try 和 catch 关键字可以捕获异常。try/catch 代码块放在异常可能发生的地方。

try/catch代码块中的代码称为保护代码,其基本语法如下:

try
{
   // 程序代码
}catch(ExceptionName e1)
{
   // Catch 块
}catch(ExceptionName e2)	//e2需比e1范围更大
{
   // Catch 块
}finally {
   // 终究会执行
}

示例:

package com.wmwx.exception;

public class Demo02 {
    public static void main(String[] args) {
        int a = 11;
        int b = 0;

        //快捷键 ctrl+alt+T
        try{                                //try 监控区域
            System.out.println(a/b);
        }catch (ArithmeticException e){     //catch 捕获异常(参数是异常类型)
            System.out.println("程序出现异常,变量b不能为0!");
        }finally {                          //finally 善后工作
            System.out.println("finally终究会被执行。");
        }

        try{                                //监控区域
            new Demo02().a();
        }catch (StackOverflowError e){      //捕获异常,多个类别需要从小到大
            System.out.println("StackOverflowError");   //会输出
        }catch (Exception e){
            System.out.println("Exception");            //不会输出
        }catch (Throwable t){
            System.out.println("Throwable");            //不会输出
        }finally {                          //善后工作
            System.out.println("finally终究会被执行。");
        }
    }

    public void a(){
        b();
    }

    public void b(){
        a();
    }
}

抛出异常

如果一个方法没有捕获到一个检查性异常,那么该方法必须使用 throws 关键字来声明。throws 关键字放在方法签名的尾部。

也可以使用 throw 关键字抛出一个异常,无论它是新实例化的还是刚捕获到的。

注意:两种方式的拼写不同,第一种末尾有 s,第二种没有。

示例:

package com.wmwx.exception;

public class Demo03 {
    public static void main(String[] args) {
        int a = 11;
        int b = 0;

        try {
            new Demo03().devide(a, b);
        } catch (ArithmeticException e) {
            e.printStackTrace();
        } finally {
        }
    }

    //假设在方法中无法处理异常,可以用throws主动抛出异常
    public void devide(int a, int b) throws ArithmeticException{
        if (b==0){
            throw new ArithmeticException();    //使用throw主动抛出异常,一般用在方法中
        }
        System.out.println(a / b);
    }
}

自定义异常

使用Java内置的异常类可以描述在编程时出现的大部分异常精况。除此之外,用户还可以自定义异常,只需继承Exception类即可。

示例:

MyException类(自定义异常类):

package com.wmwx.exception;

//自定义的异常类
public class MyException extends Exception{
    //假设:当传递过来的数字大于10时抛出异常
    private int detail;
    //构造方法
    public MyException(int a) {
        this.detail = a;
    }
    //toString 打印异常信息
    @Override
    public String toString() {
        return "MyException{detail=" + detail + "}";
    }
}

Demo04类(测试类):

package com.wmwx.exception;

//自定义异常的测试类
public class Demo04 {
    //可能会存在异常的方法
    public void test(int a) throws MyException {
        System.out.println("传递的参数为:"+a);
        if (a>10){
            throw new MyException(a);   //抛出异常
        }
        System.out.println("没有异常!");
    }

    public static void main(String[] args) {
        try {
            new Demo04().test(5);       //没有异常
            new Demo04().test(15);      //有异常
        } catch (MyException e) {
            System.out.println("MyException => " + e);
        }
    }
}

经验总结

  • 处理运行时异常时,采用逻辑去合理规避,同时辅助 try-catch 处理。
  • 在多重catch块后面,可以加一个 catch (Exception) 来处理可能会被遗漏的异常。对于不确定的代码,也可以加上try-catch,处理潜在的异常。
  • 尽量去处理异常,切忌只是简单地调用 printStackTrace() 去打印输出。具体如何处理异常,要根据不同的业务需求和异常类型去决定。
  • 尽量添加 finally 语句块去释放占用的资源。

原文链接:https://www.cnblogs.com/wmwx/p/14465940.html



所属网站分类: 技术文章 > 博客

作者:天使的翅膀

链接:http://www.javaheidong.com/blog/article/112299/2387739224ff8be5fe17/

来源:java黑洞网

任何形式的转载都请注明出处,如有侵权 一经发现 必将追究其法律责任

27 0
收藏该文
已收藏

评论内容:(最多支持255个字符)